diff --git a/gdb/cli/cli-cmds.c b/gdb/cli/cli-cmds.c
index 5f3b973f06..6964f9e1ab 100644
--- a/gdb/cli/cli-cmds.c
+++ b/gdb/cli/cli-cmds.c
@@ -24,6 +24,8 @@
 #include "completer.h"
 #include "target.h"	/* For baud_rate, remote_debug and remote_timeout.  */
 #include "common/gdb_wait.h"	/* For shell escape implementation.  */
+#include "gdbcmd.h"
+#include "gdbthread.h"
 #include "gdb_regex.h"	/* Used by apropos_command.  */
 #include "gdb_vfork.h"
 #include "linespec.h"
@@ -854,6 +856,86 @@ edit_command (const char *arg, int from_tty)
   xfree (p);
 }
 
+/* Implementation of the "pipe" command.  */
+
+static void
+pipe_command (const char *arg, int from_tty)
+{
+  FILE *to;
+  const char *shell_command = arg;
+
+  if (arg == NULL)
+    error (_("Missing \"[COMMAND] | SHELL_COMMAND\""));
+
+  while (*shell_command && *shell_command != '|')
+    shell_command++;
+
+  if (*shell_command != '|')
+    error (_("Missing | SHELL_COMMAND in \"| [COMMAND] | SHELL_COMMAND\""));
+
+  arg = skip_spaces (arg);
+  std::string gdb_cmd (arg, shell_command - arg);
+
+  if (gdb_cmd.length () == 0)
+    {
+      repeat_previous ();
+      gdb_cmd = skip_spaces (saved_command_line);
+      if (gdb_cmd.length () == 0)
+	error (_("No previous command to relaunch"));
+    }
+
+  shell_command++; /* skip the |.  */
+  shell_command = skip_spaces (shell_command);
+  if (*shell_command == 0)
+    error (_("Missing SHELL_COMMAND in \"| [COMMAND] | SHELL_COMMAND\""));
+
+  to = popen (shell_command, "w");
+  if (to == NULL)
+    error (_("Error launching \"%s\""), shell_command);
+
+  try
+    {
+      std::string gdb_cmd_result;
+      {
+	/* In case GDB_CMD switches of inferior/thread/frame, the below
+	   restores the inferior/thread/frame.  */
+	scoped_restore_current_thread restore;
+
+	gdb_cmd_result = execute_command_to_string (gdb_cmd.c_str (),
+						    from_tty);
+
+	if (fwrite (gdb_cmd_result.c_str (), 1, gdb_cmd_result.length (), to)
+	    != gdb_cmd_result.length ())
+	  {
+	    error (_("error writing \"%s\" result to \"%s\", errno %s"),
+		   gdb_cmd.c_str (), shell_command, safe_strerror (errno));
+	  }
+      }
+    }
+  catch (const gdb_exception_error &ex)
+    {
+      pclose (to);
+      throw;
+    }
+
+  int shell_command_status = pclose (to);
+  if (shell_command_status < 0)
+    error (_("shell command  \"%s\" errno %s"), shell_command,
+           safe_strerror (errno));
+  if (shell_command_status > 0)
+    {
+      if (WIFEXITED (shell_command_status))
+	warning (_("shell command \"%s\" exit status %d"), shell_command,
+		 WEXITSTATUS (shell_command_status));
+      else if (WIFSIGNALED (shell_command_status))
+	warning (_("shell command \"%s\" exit with signal %d"), shell_command,
+		 WTERMSIG (shell_command_status));
+      else
+	warning (_("shell command \"%s\" status %d"), shell_command,
+		 shell_command_status);
+    }
+}
+
 static void
 list_command (const char *arg, int from_tty)
 {
@@ -1845,6 +1927,15 @@ Uses EDITOR environment variable contents as editor (or ex as default)."));
 
   c->completer = location_completer;
 
+  c = add_com ("pipe", class_support, pipe_command, _("\
+Send the output of a gdb command to a shell command.\n\
+Usage: pipe [COMMAND] | SHELL_COMMAND\n\
+Usage: | [COMMAND] | SHELL_COMMAND\n\
+Executes COMMAND and sends its output to SHELL_COMMAND.\n\
+With no COMMAND, repeat the last executed command\n\
+and send its output to SHELL_COMMAND."));
+  add_com_alias ("|", "pipe", class_support, 0);
+
   add_com ("list", class_files, list_command, _("\
 List specified function or line.\n\
 With no argument, lists ten more lines after or around previous listing.\n\
diff --git a/gdb/cli/cli-decode.c b/gdb/cli/cli-decode.c
index 50430953c7..46051090cd 100644
--- a/gdb/cli/cli-decode.c
+++ b/gdb/cli/cli-decode.c
@@ -1311,9 +1311,9 @@ find_command_name_length (const char *text)
      Note that this is larger than the character set allowed when
      creating user-defined commands.  */
 
-  /* Recognize '!' as a single character command so that, e.g., "!ls"
+  /* Recognize the single character commands so that, e.g., "!ls"
      works as expected.  */
-  if (*p == '!')
+  if (*p == '!' || *p == '|')
     return 1;
 
   while (isalnum (*p) || *p == '-' || *p == '_'