diff --git a/gdb/cli/cli-cmds.c b/gdb/cli/cli-cmds.c
index bb2b04ddd86..1e0fc9f2b75 100644
--- a/gdb/cli/cli-cmds.c
+++ b/gdb/cli/cli-cmds.c
@@ -686,7 +686,7 @@ exit_status_set_internal_vars (int exit_status)
   else if (WIFSIGNALED (exit_status))
     set_internalvar_integer (var_signal, WTERMSIG (exit_status));
   else
-    warning (_("unexpected shell command exit status %d\n"), exit_status);
+    warning (_("unexpected shell command exit status %d"), exit_status);
 }
 
 static void
diff --git a/gdb/dwarf-index-cache.c b/gdb/dwarf-index-cache.c
index 9513891a45f..7222f0528d7 100644
--- a/gdb/dwarf-index-cache.c
+++ b/gdb/dwarf-index-cache.c
@@ -115,7 +115,7 @@ index_cache::store (struct dwarf2_per_objfile *dwarf2_per_objfile)
       /* Try to create the containing directory.  */
       if (!mkdir_recursive (m_dir.c_str ()))
 	{
-	  warning (_("index cache: could not make cache directory: %s\n"),
+	  warning (_("index cache: could not make cache directory: %s"),
 		   safe_strerror (errno));
 	  return;
 	}
diff --git a/gdb/gdbserver/linux-s390-low.c b/gdb/gdbserver/linux-s390-low.c
index f65a1ec38ef..b23e3b1af6f 100644
--- a/gdb/gdbserver/linux-s390-low.c
+++ b/gdb/gdbserver/linux-s390-low.c
@@ -479,7 +479,7 @@ s390_get_wordsize (int pid)
 				  (PTRACE_TYPE_ARG4) 0);
   if (errno != 0)
     {
-      warning (_("Couldn't determine word size, assuming 64-bit.\n"));
+      warning (_("Couldn't determine word size, assuming 64-bit."));
       return 8;
     }
   /* Derive word size from extended addressing mode (PSW bit 31).  */
diff --git a/gdb/gdbserver/linux-x86-low.c b/gdb/gdbserver/linux-x86-low.c
index adddfe77971..e84e7a1793c 100644
--- a/gdb/gdbserver/linux-x86-low.c
+++ b/gdb/gdbserver/linux-x86-low.c
@@ -1481,7 +1481,7 @@ x86_get_min_fast_tracepoint_insn_len (void)
 	     mention that something has gone awry.  */
 	  if (!warned_about_fast_tracepoints)
 	    {
-	      warning ("4-byte fast tracepoints not available; %s\n", errbuf);
+	      warning ("4-byte fast tracepoints not available; %s", errbuf);
 	      warned_about_fast_tracepoints = 1;
 	    }
 	  return 5;
diff --git a/gdb/gdbserver/remote-utils.c b/gdb/gdbserver/remote-utils.c
index 1d27ea31e2c..7c495beb7cd 100644
--- a/gdb/gdbserver/remote-utils.c
+++ b/gdb/gdbserver/remote-utils.c
@@ -1558,7 +1558,7 @@ look_up_one_symbol (const char *name, CORE_ADDR *addrp, int may_ask_gdb)
 
   if (!startswith (cs.own_buf, "qSymbol:"))
     {
-      warning ("Malformed response to qSymbol, ignoring: %s\n", cs.own_buf);
+      warning ("Malformed response to qSymbol, ignoring: %s", cs.own_buf);
       return -1;
     }
 
@@ -1659,14 +1659,14 @@ relocate_instruction (CORE_ADDR *to, CORE_ADDR oldloc)
 
   if (cs.own_buf[0] == 'E')
     {
-      warning ("An error occurred while relocating an instruction: %s\n",
+      warning ("An error occurred while relocating an instruction: %s",
 	       cs.own_buf);
       return -1;
     }
 
   if (!startswith (cs.own_buf, "qRelocInsn:"))
     {
-      warning ("Malformed response to qRelocInsn, ignoring: %s\n",
+      warning ("Malformed response to qRelocInsn, ignoring: %s",
 	       cs.own_buf);
       return -1;
     }
diff --git a/gdb/gdbserver/thread-db.c b/gdb/gdbserver/thread-db.c
index d4d4958c73e..387f22f487e 100644
--- a/gdb/gdbserver/thread-db.c
+++ b/gdb/gdbserver/thread-db.c
@@ -227,7 +227,7 @@ attach_thread (const td_thrhandle_t *th_p, td_thrinfo_t *ti_p)
     {
       std::string reason = linux_ptrace_attach_fail_reason_string (ptid, err);
 
-      warning ("Could not attach to thread %ld (LWP %d): %s\n",
+      warning ("Could not attach to thread %ld (LWP %d): %s",
 	       (unsigned long) ti_p->ti_tid, ti_p->ti_lid, reason.c_str ());
 
       return 0;
@@ -907,5 +907,5 @@ thread_db_notice_clone (struct thread_info *parent_thr, ptid_t child_ptid)
     = make_scoped_restore (&current_thread, parent_thr);
 
   if (!find_one_thread (child_ptid))
-    warning ("Cannot find thread after clone.\n");
+    warning ("Cannot find thread after clone.");
 }
diff --git a/gdb/gdbserver/tracepoint.c b/gdb/gdbserver/tracepoint.c
index 9577ab7f1e9..98d28e9bb28 100644
--- a/gdb/gdbserver/tracepoint.c
+++ b/gdb/gdbserver/tracepoint.c
@@ -7194,7 +7194,7 @@ gdb_agent_helper_thread (void *arg)
 
       if (listen_fd == -1)
 	{
-	  warning ("could not create sync socket\n");
+	  warning ("could not create sync socket");
 	  break;
 	}
 
@@ -7218,7 +7218,7 @@ gdb_agent_helper_thread (void *arg)
 
 	  if (fd < 0)
 	    {
-	      warning ("Accept returned %d, error: %s\n",
+	      warning ("Accept returned %d, error: %s",
 		       fd, strerror (errno));
 	      break;
 	    }
diff --git a/gdb/guile/guile.c b/gdb/guile/guile.c
index 9247fd64122..a426c3c640b 100644
--- a/gdb/guile/guile.c
+++ b/gdb/guile/guile.c
@@ -568,7 +568,7 @@ handle_boot_error (void *boot_scm_file, SCM key, SCM args)
   warning (_("Could not complete Guile gdb module initialization from:\n"
 	     "%s.\n"
 	     "Limited Guile support is available.\n"
-	     "Suggest passing --data-directory=/path/to/gdb/data-directory.\n"),
+	     "Suggest passing --data-directory=/path/to/gdb/data-directory."),
 	   (const char *) boot_scm_file);
 
   return SCM_UNSPECIFIED;
diff --git a/gdb/m32c-tdep.c b/gdb/m32c-tdep.c
index a28c5d8e81f..657c6b7930f 100644
--- a/gdb/m32c-tdep.c
+++ b/gdb/m32c-tdep.c
@@ -2452,7 +2452,7 @@ m32c_m16c_address_to_pointer (struct gdbarch *gdbarch,
 		   "couldn't find trampoline named '%s.plt'.\n"
 		   "Returning pointer value %s instead; this may produce\n"
 		   "a useful result if converted back into an address by GDB,\n"
-		   "but will most likely not be useful otherwise.\n"),
+		   "but will most likely not be useful otherwise."),
 		   paddress (gdbarch, addr), func_name,
 		   paddress (gdbarch, ptrval));
 
diff --git a/gdb/nat/fork-inferior.c b/gdb/nat/fork-inferior.c
index fe9360a5039..1179d01c04f 100644
--- a/gdb/nat/fork-inferior.c
+++ b/gdb/nat/fork-inferior.c
@@ -425,7 +425,7 @@ fork_inferior (const char *exec_file_arg, const std::string &allargs,
       for (i = 1; argv[i] != NULL; i++)
 	warning (" %s", argv[i]);
 
-      warning ("Error: %s\n", safe_strerror (save_errno));
+      warning ("Error: %s", safe_strerror (save_errno));
 
       _exit (0177);
     }
diff --git a/gdb/python/python.c b/gdb/python/python.c
index 4dad8ec10d1..98b9467c6eb 100644
--- a/gdb/python/python.c
+++ b/gdb/python/python.c
@@ -1876,7 +1876,7 @@ do_finish_initialization (const struct extension_language_defn *extlang)
       warning (_("\n"
 		 "Could not load the Python gdb module from `%s'.\n"
 		 "Limited Python support is available from the _gdb module.\n"
-		 "Suggest passing --data-directory=/path/to/gdb/data-directory.\n"),
+		 "Suggest passing --data-directory=/path/to/gdb/data-directory."),
 	       gdb_pythondir.c_str ());
       /* We return "success" here as we've already emitted the
 	 warning.  */
diff --git a/gdb/s12z-tdep.c b/gdb/s12z-tdep.c
index b549862e842..fa27b58e56e 100644
--- a/gdb/s12z-tdep.c
+++ b/gdb/s12z-tdep.c
@@ -90,8 +90,8 @@ s12z_skip_prologue (struct gdbarch *gdbarch, CORE_ADDR pc)
         return prologue_end;
     }
 
-  warning (_("%s Failed to find end of prologue PC = %08x\n"),
-                      __FUNCTION__, (unsigned int) pc);
+  warning (_("%s Failed to find end of prologue PC = %08x"),
+	   __FUNCTION__, (unsigned int) pc);
 
   return pc;
 }
@@ -296,7 +296,7 @@ s12z_frame_cache (struct frame_info *this_frame, void **prologue_cache)
   /* Return early if GDB couldn't find the function.  */
   if (start_addr == 0)
     {
-      warning (_("Couldn't find function including address %s SP is %s\n"),
+      warning (_("Couldn't find function including address %s SP is %s"),
                paddress (gdbarch, this_pc),
                paddress (gdbarch, this_sp));
 
diff --git a/gdb/solib-svr4.c b/gdb/solib-svr4.c
index 2828c96c683..8cd5b7d8e70 100644
--- a/gdb/solib-svr4.c
+++ b/gdb/solib-svr4.c
@@ -1858,7 +1858,7 @@ static void
 disable_probes_interface (svr4_info *info)
 {
   warning (_("Probes-based dynamic linker interface failed.\n"
-	     "Reverting to original interface.\n"));
+	     "Reverting to original interface."));
 
   free_probes_table (info);
   free_solib_list (info);